unit corbalaskuri;
(*
    Autolaskuri CORBA-palvelimena
    Miika Nurminen, 27.8.2004
*)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Corba, testi_c, testi_i, testi_impl, testi_s, StdCtrls;

type
  TForm1 = class(TForm)
    ButtonStart: TButton;
    LabelHA: TLabel;
    LabelKA: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure ButtonStartClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
  { private declarations }
  protected
  { protected declarations }
    // Add Corba interface variables here like this
    // Acct : Account; // skeleton object
    LaskuriHA: iCarCounter;
    LaskuriKA: iCarCounter;
    procedure InitCorba;
    procedure OnHaChange(Sender:TObject);
    procedure OnKaChange(Sender:TObject);
  public
  { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.InitCorba;
var tha,tka:TiCarCounter;
begin
  CorbaInitialize;

  // Add CORBA server code here like this
  // Acct := TAccountSkeleton.Create('Jack B Quick', TAccount.Create);
  // BOA.ObjIsReady(Acct as _Object);

  tha := TiCarCounter.Create;
  LaskuriHA := TiCarCounterSkeleton.Create('HA',tha);
  tha.OnChange:=OnHaChange; // palvelimen kyttliittym varten

  tka := TiCarCounter.Create;
  LaskuriKA := TiCarCounterSkeleton.Create('KA',tka);
  tka.OnChange:=OnKaChange; // palvelimen kyttliittym varten

  BOA.ObjIsReady(LaskuriHa as _Object);
  BOA.ObjIsReady(LaskuriKa as _Object);

  LaskuriHa.Clear;
  LaskuriKa.Clear;

end;

procedure TForm1.ButtonStartClick(Sender: TObject);
begin
  InitCorba;
  ButtonStart.Enabled:=false;
  Caption:='CarCounter Server running...';
  Button1.Enabled:=true;
  Button2.Enabled:=true;
end;

procedure TForm1.OnHaChange(Sender: TObject);
begin
  LabelHa.Caption:=IntToStr(LaskuriHa.Count);
end;

procedure TForm1.OnKaChange(Sender: TObject);
begin
  LabelKa.Caption:=IntToStr(LaskuriKa.Count);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  LaskuriHa.Inc;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  LaskuriKa.Inc;
end;

end.